<?php

namespace Shqawe\BestUserInXTime;

Class Listener{

    public static function appSetup(\XF\App $app)
    {
        $options = \XF::options();
        $container = $app->container();
        
        $container['bw_bestThreadsWriter'] = $app->fromRegistry('bw_bestThreadsWriter',
            function(\XF\Container $c) {
                $options = \XF::options();
                return $c['em']->getRepository('Shqawe\BestUserInXTime\XF:BuserRepo')->rebuildBestThreadsWriter($options->bw_no_days);
            }
        );
        
        $container['bw_bestPostsWriter'] = $app->fromRegistry('bw_bestPostsWriter',
            function(\XF\Container $c) {
                $options = \XF::options();
                return $c['em']->getRepository('Shqawe\BestUserInXTime\XF:BuserRepo')->rebuildBestPostsWriter($options->bw_no_days);
            }
        );
        
        $container['bw_PobularPost'] = $app->fromRegistry('bw_PobularPost',
            function(\XF\Container $c) {
                $options = \XF::options();
                return $c['em']->getRepository('Shqawe\BestUserInXTime\XF:BuserRepo')->rebuildPobularPost($options->bw_no_days);
            }
        );
        
        $container['bw_ActivePost'] = $app->fromRegistry('bw_ActivePost',
            function(\XF\Container $c) {
                $options = \XF::options();
                return $c['em']->getRepository('Shqawe\BestUserInXTime\XF:BuserRepo')->rebuildActivePost($options->bw_no_days);
            }
        );
    }

    public static function getThreadWriter(
        \XF\Template\Templater $templater, &$type, &$template, array &$params
        )
    {
        
        $app = \XF::app();
        $params['bestThreadwriter'] = $app->container('bw_bestThreadsWriter');
        return $params;
    }

    public static function getPostWriter(
        \XF\Template\Templater $templater, &$type, &$template, array &$params
        )
    {
        $app = \XF::app();
        $params['bestPostwriters'] = $app->container('bw_bestPostsWriter');
        return $params;
    }

    public static function getPopularThread(
        \XF\Template\Templater $templater, &$type, &$template, array &$params
        )
    {
        $app = \XF::app();
        $params['pobularThread'] = $app->container('bw_PobularPost');
        return $params;
    }

    public static function getActiveThread(
        \XF\Template\Templater $templater, &$type, &$template, array &$params
        )
    {
        $app = \XF::app();
        $params['activeThread'] = $app->container('bw_ActivePost');
        return $params;
    }

    
}